
===============================================================
ug3 RELEASE NOTES: 09/08/25 RELEASE VERSION 5.0.2
===============================================================

Enhancements/ Additions:
------------------------

* Changes to insure face and element ID flags are set >0.

Bugs Fixed:
-----------

===============================================================
ug3 RELEASE NOTES: 11/03/24 RELEASE VERSION 5.0.1
===============================================================

Enhancements/ Additions:
------------------------

* Changes for adding boundary-edge data to I/O routines.

Bugs Fixed:
-----------


===============================================================
ug3 RELEASE NOTES: 11/28/23 RELEASE VERSION 4.99.11
===============================================================

Enhancements/ Additions:
------------------------

* Added routine ug3_conv_2d_mesh_3d to convert a 2D planar mesh
  to an axisymmetric or stacked plane 3D mesh.

* Added capability to generate prism-elements with
  ug3_conv_2d_mesh_3d.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 07/12/23 RELEASE VERSION 4.99.4
===============================================================

Enhancements/ Additions:
------------------------

* Added routines ug3_inibe and ug3_merge_mesh.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 04/13/23 RELEASE VERSION 4.98.17
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Fixed bug in conversion of trias to quads routine ug3_triaq.

===============================================================
ug3 RELEASE NOTES: 11/20/22 RELEASE VERSION 4.98.16
===============================================================

Enhancements/ Additions:
------------------------

* Changed all sprintf calls to snprintf.

Bugs Fixed:
-----------

* Corrected coefficient in formula to determine quad face
  area-length-ratio. It was 4 and now is the correct value of 2.

===============================================================
ug3 RELEASE NOTES: 07/18/22 RELEASE VERSION 4.98.11
===============================================================

Enhancements/ Additions:
------------------------

* Added internal surface face ID flag allocation in NULL on
  input in ug3_write_surf_grid_file.

* Added AFLR4 to applicable list of codes for TRANSP_SRC_UG3_GBC
  in ug3_set_ibcibf.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 05/25/22 RELEASE VERSION 4.98.9
===============================================================

Enhancements/ Additions:
------------------------

* Removed message flag from ug3_qchk API.

* Added backup file creation when writing a MESH surface or
  volume mesh file.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 11/26/21 RELEASE VERSION 4.97.12
===============================================================

Enhancements/ Additions:
------------------------

* Add check if volume element ID is already check within
  element ID creation routine ug3_idiel.

* Added routine ug3_write_mesh0 to write MESH grid files if an
  external routine for writing MESH and MESHB files is not
  registered.

Bugs Fixed:
-----------

* Fixed potential divide by 0 in ug3_write_qvlrchk.

===============================================================
ug3 RELEASE NOTES: 04/10/21 RELEASE VERSION 4.96.21
===============================================================

Enhancements/ Additions:
------------------------

* Modified body map routine ug3_iboibf0 to only ignore
  transparent bodies.

* Modified BC setting routine ug3_set_ibcibf.

* Added new routine to set tet-element IDs. The new routine is
  ug3_idiel and the original ug3_idiel was renamed ug3_idiel2.

* Modified volume-length ratio Q measure aspect-ratio scaling
  for pyramids.

* Added overall scaling adjustment for volume-length ratio Q
  measure to insure Q is always less than one.

Bugs Fixed:
-----------

* Correct indexing for Volume ID in low-memory write mode using
  ug3_write_ugrid.

===============================================================
ug3 RELEASE NOTES: 12/15/20 RELEASE VERSION 4.95.4
===============================================================

Enhancements/ Additions:
------------------------

* Modified duplication of BL generating transparent faces to allow
  NULL optional data in ug3_tbfd*.

* Added qchk_* generation of a skew biased quality measure.

* Added option to output a skew biased quality measure using the
  new parameter m_qvrrchk=1. By default this output is off.

Bugs Fixed:
-----------

* Corrected qchk output of hex-element minimum dihedral angle.

===============================================================
ug3 RELEASE NOTES: 10/29/20 RELEASE VERSION 4.94.13
===============================================================

Enhancements/ Additions:
------------------------

* Modified boundary surface checking routine ug3_chkbsurf2.

Bugs Fixed:
-----------

===============================================================
ug3 RELEASE NOTES: 05/19/20 RELEASE VERSION 4.94.6
===============================================================

Enhancements/ Additions:
------------------------

* Added routine ug3_read_surf_grid_file2 for reading grid data
  from a SURF surface grid file. This version allocates space
  with options.

Bugs Fixed:
-----------

===============================================================
ug3 RELEASE NOTES: 04/02/20 RELEASE VERSION 4.93.9
===============================================================

Enhancements/ Additions:
------------------------

* Added routine ug3_bv3 for determining boundary normal vectors
  with correction for BL intersecting surfaces (symmetry).

Bugs Fixed:
-----------

===============================================================
ug3 RELEASE NOTES: 11/15/19 RELEASE VERSION 4.92.2
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected uninitialized memory write in FUNC/SFUNC file writer,
  ug3_write_sfunc.

* Corrected memory leak in face map routine, ug3_face_map.

===============================================================
ug3 RELEASE NOTES: 07/09/19 RELEASE VERSION 4.91.4
===============================================================

Enhancements/ Additions:
------------------------

* Added area-length to edge-length ratio quality measure to 
  surface grid quality routine ug3_qchkb.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 07/05/19 RELEASE VERSION 4.91.2
===============================================================

Enhancements/ Additions:
------------------------

* Removed error output from split or non-matching faces from
  ug3_qchk.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 06/23/19 RELEASE VERSION 4.91.1
===============================================================

Enhancements/ Additions:
------------------------

* Added new capability for surface grid quality that is accessible 
  through routine ug3_qchkb.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 05/13/19 RELEASE VERSION 4.90.3
===============================================================

Enhancements/ Additions:
------------------------

* Added check routine ug3_chkbsurf3 which combines ug3_chkbsurf2
  and boundary object routine ug3_iboibf0.

* Modified boundary surface connectivity check routine ug3_chkbsurf2
  to use the new ug3_chkbsurf3 routine.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 02/28/19 RELEASE VERSION 4.89.4
===============================================================

Enhancements/ Additions:
------------------------

* Modified BC check routine ug3_chkbc0 for FarField BCs.

* Modified boundary surface connectivity check routine ug3_chkbsurf2.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 11/14/18 RELEASE VERSION 4.88.2
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Removed possible divide by zero while re-setting the reconnection
  flag and while converting quad-faces to tria-faces. This is in
  ug3_set_irfibf and in ug3_qtria.

===============================================================
ug3 RELEASE NOTES: 11/06/18 RELEASE VERSION 4.88.1
===============================================================

Enhancements/ Additions:
------------------------

* Moved routine ug3_face_sort from UG_CPP lib to UG3 lib.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 10/16/18 RELEASE VERSION 4.87.3
===============================================================

Enhancements/ Additions:
------------------------

* Added BL-aspect-ratio scaling to Q quality function ug3_qvlr.

Bugs Fixed:
-----------

* Corrected memory error in element neighbor volume ratio quality
  functions, ug3_write_volrchk and ug3_write_volrchk2.

===============================================================
ug3 RELEASE NOTES: 10/07/18 RELEASE VERSION 4.86.9
===============================================================

Enhancements/ Additions:
------------------------

* Added function ug3_qchk to output element quality measures.

* Added functions ug3_dxchk and ug3_write_dxchk to evaluate
  element edge lengths and search for edges that are too short.

* Added function ug3_chkbsurf2 as an reduced form of boundary
  surface mesh checking.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 07/16/18 RELEASE VERSION 4.85.7
===============================================================

Enhancements/ Additions:
------------------------

* Added ug3_p2_tet_q with capability to evaluate a P2-Tet element
  quality measure

* Added ug3_conv_p1_to_p2 with capability to convert a standard P1
  mesh into a P2 mesh defined by a P1+P2_complement mesh.

* Added ug3_conv_p2_to_p1 with capability to convert a P2 mesh
  defined by a P1+P2_complement mesh to a P1 boundary surface
  sub-mesh.

* Added capability for P2-faces with ug3_bnd_nodes and ug3_nnodeb.

* Added option to skip check for nodes not included within the
  surface mesh within ug3_chkbn.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 05/23/18 RELEASE VERSION 4.84.11
===============================================================

Enhancements/ Additions:
------------------------

* Added grid BC definition FARFIELD_UG3_GBC that is identical to
  the previous STD_NULL_UG3_GBC definition. The FARFIELD_UG3_GBC
  is treated the same as a standard surface STD_UG3_GBC except
  with AFLR4 in auto mode where farfield surfaces are handled
  differently.

Bugs Fixed:
-----------

* Corrected usage of BC flag information within ug3_ibor.

===============================================================
ug3 RELEASE NOTES: 04/08/18 RELEASE VERSION 4.84.9
===============================================================

Enhancements/ Additions:
------------------------

* Added routines to determine element quality measures, volume,
  and volume ratio.

* Added routines to output information on element quality measures,
  volume, and volume ratio.

* Added routine ug3_face_map to set the face map data structure
  for a given volume grid.

* Added routine ug3_read_split_data_file to read hex-element
  split-face data from a SPLIT data file.

* Added setting of boundary data, if requested, in reading UGRID
  grid data files whether the file includes the data or not.

* Added routine ug3_mq_elem to set a flag for low-quality regions.

* Added routine ug3_msd_elem to set sub-domain boundary flag.

* Modified treatment of sub-domain partition boundaries.

* Added routine ug3_nelem_est to estimate the total number of
  elements that will be generated.

* Added routine ug3_ibfibf2 with internal memory allocation.

* Added routines to read and write BGDATA background mesh and
  function data files.

* Added setting default values for the Grid BC Flag and
  Reconnection Flag when reading UGRID type files.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 06/13/17 RELEASE VERSION 4.78.58
===============================================================

Enhancements/ Additions:
------------------------

* Added full read/write capability for both UGRID and MESH
  grid file types along with both SFUNC and SOL function file
  types.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 05/11/17 RELEASE VERSION 4.77.57
===============================================================

Enhancements/ Additions:
------------------------

* Added reordering to list of elements containing boundary faces 
  in routine ug3_ielibf.

* Removed unused variables.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 04/24/17 RELEASE VERSION 4.76.56
===============================================================

Enhancements/ Additions:
------------------------

* Changed fixed arrays assigned by ug3_bv_ls to temporary
  allocations.

* Modified definition of grid boundary condition PART_UG3_GBC to
  match current usage. Also, deleted the grid boundary condition
  PART_STD_UG3_GBC as it is no longer used.

* Modified API for ug3_ibor.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 02/23/17 RELEASE VERSION 4.74.48
===============================================================

Enhancements/ Additions:
------------------------

* Moved ice3_split_data routines to UG3 library (removes ANBL3 dependency on
  ICE3 library).

* Moved ug_io_split_data routines to UG3 library.

* Changes for compatibility with 64-bit integers.

* Modified boundary surface reordering for revised "open" mode
  with mopen=1 & mopen=2.

* Modified included angle check for surfaces that intersect the BL region
  to include transparent BL generating surfaces as possible neighbors.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 12/16/16 RELEASE VERSION 4.70.44
===============================================================

Enhancements/ Additions:
------------------------

* Moved ug3_glue and ug3_reorder_bsurf to OTB_LIB as otb_glue
  and otb_reorder_bsurf.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 12/06/16 RELEASE VERSION 4.69.44
===============================================================

Enhancements/ Additions:
------------------------

* Added routine to determin body index map with internal memory
  allocation.

* Added capability for glueing and reordering grids with hex-elements
  that have 2:1 split faces.

* Added most-visible normal vector method to normal vector routines.
  The parameter mbv_mode now controls the method for normal vector
  determination.
  If mbv_mode = 1 then use LS method to determine the node normal
  vector that has the minimum deviation with respect to the
  surrounding face normal vectors. This is the default.
  If mbv_mode = 2 then use a most-visible method to determine the
  node normal  vector that maximizes the minimum tetrahedral volume
  for the surrounding faces. 
  If mbv_mode = 3 then use a simple averaging method to determine
  the node  normal vector. 

* Added determinant tolerance to least-squares normal vector
  algorithm.

* Added routine ug3_idibf2 to set boundary surface face IDs
  based on surface discontinuity.

* Added routine ug3_iqin to create a list of quad faces
  surrounding a node.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 08/09/16 RELEASE VERSION 4.64.10
===============================================================

Enhancements/ Additions:
------------------------

* Added Grid BC type definition for temporary sub-domain internal
  guide surface faces.

* Added alternative grid file read/write routines that include
  all boundary surface data.

* Modified routines for determining least-squares optimized
  boundary surface normals. Renamed ug3_bvls as ug3_bv_ls.

* Added volume ID flag to routines that write a grid file.

* Modified process to determine boundary node index map in
  ug3_bnd_nodes.

* Removed option to turn off input surface face angle check with
  angqbf=0 (option to use angqbf=180 remains).

* Added capability to read and write both UGRID and MESH(B) files
  in all supported formats.

* Added ug3_reorderb2 simplified routine to renumber nodes with
  boundary nodes first.

* Added volume element ID flag to UGRID file reader.

Bugs Fixed:
-----------

* Corrected error reading TMP files that impacted routines
  ug3_read_ugrid, ug3_read_grid_file, and ug3_read_grid_file2.

* Eliminated memory leak in ug3_chkbsurf0 boundary surface check.

===============================================================
ug3 RELEASE NOTES: 01/23/16 RELEASE VERSION 4.50.110
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Added initialization of boundary face error flag after reallocation.

* Corrected an error in always reporting that a closed embedded
  transparent BL generating surface was found whenever there were
  any transparent BL generating surfaces

===============================================================
ug3 RELEASE NOTES: 12/09/15 RELEASE VERSION 4.48.109
===============================================================

Enhancements/ Additions:
------------------------

* Moved all dftr3_df* routines to library UG3 as ug3_df*.

Bugs Fixed:
-----------

* Corrected an error in the version of boundary surface checking
  without reconnection.

===============================================================
ug3 RELEASE NOTES: 11/30/15 RELEASE VERSION 4.47.104
===============================================================

Enhancements/ Additions:
------------------------

* Modified body surface mesh reordering for closed cases that are
  do not have the open flag set on.

Bugs Fixed:
-----------

* Removed an incorrect error check that could be be flagged as
  an error with input or output of edge grid files.

===============================================================
ug3 RELEASE NOTES: 09/20/15 RELEASE VERSION 4.45.101
===============================================================

Enhancements/ Additions:
------------------------

*

Bugs Fixed:
-----------

* Corrected boundary renumbering issue with sub-grid insertion.

===============================================================
ug3 RELEASE NOTES: 07/20/15 RELEASE VERSION 4.44.101
===============================================================

Enhancements/ Additions:
------------------------

* Modified maximum output precision for double data with ASCII
  files.

* Modified volume calculations and checking so that consistent
  checks are possible.

* Moved pyramid transition routines to AFLR3_LIB.

* Modified glue routine to allow for a boundary surface to be
  partially contained within multiple sub-grids.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 06/10/15 RELEASE VERSION 4.42.95
===============================================================

Enhancements/ Additions:
------------------------

* Added a routine, ug3_glue, to glue two grids together.

* Added a routine, ug3_chkbsurf0, to check and reorder a boundary
  surface grid.

* Added a routine, ug3_reorder_bsurf, to reorder the boundary nodes
  of a given mesh to match those of a second mesh.

* Added quad faces to determination of number of boundary nodes
  using ug3_nnodeb.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 04/27/15 RELEASE VERSION 4.40.80
===============================================================

Enhancements/ Additions:
------------------------

* Added routine to convert trias to trias/quads for a tria mesh
  that was previously converted from trias/quads to trias.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 02/25/15 RELEASE VERSION 4.39.79
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for BL generating embedded/transparent surfaces 
  that have non-manifold (multiple) connections between them and
  other embedded/transparent and/or solid surfaces.

* Modified maximum output precision for double data with ASCII files.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 08/14/14 RELEASE VERSION 4.38.71
===============================================================

Enhancements/ Additions:
------------------------

* Modified surface search (ug3_srchbf) to include a two-pass
  algorithm that uses a large tolerance on the second pass to
  find locations that are off the surface and near a surface node.

Bugs Fixed:
-----------

* 

===============================================================
ug3 RELEASE NOTES: 06/13/14 RELEASE VERSION 4.37.71
===============================================================

Enhancements/ Additions:
------------------------

* Added minimum planar surface face angle check.

* Changed return error codes that were out of sequence.

* Increased least-squares boundary normal discontinuity tolerance.

Bugs Fixed:
-----------

* Correct uninitialized variable error in least-squares boundary
  normal routine.

===============================================================
ug3 RELEASE NOTES: 02/11/14 RELEASE VERSION 4.36.64
===============================================================

Enhancements/ Additions:
------------------------

* Convert to new ug parameter structure scheme and eliminate
  use of Error_Message.

* Added r8 and lr8 UNFORMATTED FORTRAN capability to both
  ug3_read_ugrid_grid_file and ug3_write_ugrid_grid_file.

Bugs Fixed:
-----------

*


===============================================================
ug3 RELEASE NOTES: 10/26/13 RELEASE VERSION 4.35.51
===============================================================

Enhancements/ Additions:
------------------------

* Added routine to modify transparent surfaces used to generate
  a BL region in the field. Tria-faces at isolated corners (two
  edges have no face neighbor) are now automatically split.

* Removed quad/tria face restrictions on transparent surfaces
  used to generate a BL region in the field. At present quad
  faces may be used on any type of surface including transparent
  BL generating ones.

Bugs Fixed:
-----------

* Corrected usage of mquadp flag so that pyramid transition
  occurs for quad faces that are BL generating only if mquadp=1
  or all quad faces if mquadp=2, and none if mquadp=0.

===============================================================
ug3 RELEASE NOTES: 09/12/13 RELEASE VERSION 4.33.50
===============================================================

Enhancements/ Additions:
------------------------

* Added routine to reconnect tria-faces that were created from
  quad-faces on the surface mesh. This is used in BL generation
  to obtain optimal BL normals at singular points where a normal
  visible to all faces may not be possible.

Bugs Fixed:
-----------

* Corrected potential memory error in reallocation of space for
  pyramid faces when using pyramid transition from quad-faces.

===============================================================
ug3 RELEASE NOTES: 08/25/13 RELEASE VERSION 4.32.49
===============================================================

Enhancements/ Additions:
------------------------

* Added option to vary the height of pyramid elements created
  for quad transition. The height can be based on the base
  edge lengths, BL normal spacing (if applicable) with a minimum
  limit based on the base edge lengths, or BL normal spacing
  (if applicable) only.

* Added element quality checking for elements trapped between
  pyramid elements created for quad transition and their
  opposing neighbors.

* Added convexity test for checking of pyramid elements
  created for quad transition

* Modified length scale for checking of opposing nodes
  associated with pyramid elements created for quad transition.

* Modified API for metric capability.

Bugs Fixed:
-----------

* Corrected a potential memory error during creation of pyramid
  elements for quad face to pyramid transition.

===============================================================
ug3 RELEASE NOTES: 06/16/13 RELEASE VERSION 4.27.46
===============================================================

Enhancements/ Additions:
------------------------

* Modified direct use of variables specified to be true "int"
  types (4 byte) to be compatible with global specification of
  INT_ types to be "long long int" (8 byte).

Bugs Fixed:
-----------

* Modified quad face to pyramid transition routines. Previous
  versions had potential issues with convex faces that could
  result merging of pyramid tip nodes that were OK. This often
  resulted in failure in AFLR due to a very distorted surface.

===============================================================
ug3 RELEASE NOTES: 05/29/13 RELEASE VERSION 4.25.46
===============================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Modified algorithm to determine Least-Squares surface normal
  vectors. Previous versions could produce erroneous results
  due to an ill-conditioned matrix.


===============================================================
ug3 RELEASE NOTES: 03/18/13 RELEASE VERSION 4.25.44
===============================================================

Enhancements/ Additions:
------------------------

* Added modifications to allow for very long file names. Previous
  versions are limited to file path names with about 100 characters 
  or less. The current version allows path names with about 1000
  characters (500 on Windows) or less.

Bugs Fixed:
-----------

* 


===============================================================
ug3 RELEASE NOTES: 01/17/13 RELEASE VERSION 4.24.42
===============================================================

Enhancements/ Additions:
------------------------

* Added routine ugv_bfv_i to evaluate boundary face normals at
  a specific boundary surface face.

Bugs Fixed:
-----------

* 

